<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_221) on Tue Jan 19 16:20:17 PST 2021 -->
<title>AbstractFetchSchedule (apache-nutch 1.18 API)</title>
<meta name="date" content="2021-01-19">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="AbstractFetchSchedule (apache-nutch 1.18 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/AbstractFetchSchedule.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../org/apache/nutch/crawl/AdaptiveFetchSchedule.html" title="class in org.apache.nutch.crawl"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/apache/nutch/crawl/AbstractFetchSchedule.html" target="_top">Frames</a></li>
<li><a href="AbstractFetchSchedule.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.apache.nutch.crawl</div>
<h2 title="Class AbstractFetchSchedule" class="title">Class AbstractFetchSchedule</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li><a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configured.html?is-external=true" title="class or interface in org.apache.hadoop.conf">org.apache.hadoop.conf.Configured</a></li>
<li>
<ul class="inheritance">
<li>org.apache.nutch.crawl.AbstractFetchSchedule</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configurable.html?is-external=true" title="class or interface in org.apache.hadoop.conf">Configurable</a>, <a href="../../../../org/apache/nutch/crawl/FetchSchedule.html" title="interface in org.apache.nutch.crawl">FetchSchedule</a></dd>
</dl>
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><a href="../../../../org/apache/nutch/crawl/AdaptiveFetchSchedule.html" title="class in org.apache.nutch.crawl">AdaptiveFetchSchedule</a>, <a href="../../../../org/apache/nutch/crawl/DefaultFetchSchedule.html" title="class in org.apache.nutch.crawl">DefaultFetchSchedule</a></dd>
</dl>
<hr>
<br>
<pre>public abstract class <span class="typeNameLabel">AbstractFetchSchedule</span>
extends <a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configured.html?is-external=true" title="class or interface in org.apache.hadoop.conf">Configured</a>
implements <a href="../../../../org/apache/nutch/crawl/FetchSchedule.html" title="interface in org.apache.nutch.crawl">FetchSchedule</a></pre>
<div class="block">This class provides common methods for implementations of
 <code>FetchSchedule</code>.</div>
<dl>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Andrzej Bialecki</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/nutch/crawl/AbstractFetchSchedule.html#defaultInterval">defaultInterval</a></span></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/nutch/crawl/AbstractFetchSchedule.html#maxInterval">maxInterval</a></span></code>&nbsp;</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="fields.inherited.from.class.org.apache.nutch.crawl.FetchSchedule">
<!--   -->
</a>
<h3>Fields inherited from interface&nbsp;org.apache.nutch.crawl.<a href="../../../../org/apache/nutch/crawl/FetchSchedule.html" title="interface in org.apache.nutch.crawl">FetchSchedule</a></h3>
<code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html#SECONDS_PER_DAY">SECONDS_PER_DAY</a>, <a href="../../../../org/apache/nutch/crawl/FetchSchedule.html#STATUS_MODIFIED">STATUS_MODIFIED</a>, <a href="../../../../org/apache/nutch/crawl/FetchSchedule.html#STATUS_NOTMODIFIED">STATUS_NOTMODIFIED</a>, <a href="../../../../org/apache/nutch/crawl/FetchSchedule.html#STATUS_UNKNOWN">STATUS_UNKNOWN</a></code></li>
</ul>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../org/apache/nutch/crawl/AbstractFetchSchedule.html#AbstractFetchSchedule--">AbstractFetchSchedule</a></span>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../org/apache/nutch/crawl/AbstractFetchSchedule.html#AbstractFetchSchedule-org.apache.hadoop.conf.Configuration-">AbstractFetchSchedule</a></span>(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configuration.html?is-external=true" title="class or interface in org.apache.hadoop.conf">Configuration</a>&nbsp;conf)</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>long</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/nutch/crawl/AbstractFetchSchedule.html#calculateLastFetchTime-org.apache.nutch.crawl.CrawlDatum-">calculateLastFetchTime</a></span>(<a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;datum)</code>
<div class="block">This method return the last fetch time of the CrawlDatum</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code><a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/nutch/crawl/AbstractFetchSchedule.html#forceRefetch-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-boolean-">forceRefetch</a></span>(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/io/Text.html?is-external=true" title="class or interface in org.apache.hadoop.io">Text</a>&nbsp;url,
            <a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;datum,
            boolean&nbsp;asap)</code>
<div class="block">This method resets fetchTime, fetchInterval, modifiedTime,
 retriesSinceFetch and page signature, so that it forces refetching.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code><a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/nutch/crawl/AbstractFetchSchedule.html#initializeSchedule-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-">initializeSchedule</a></span>(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/io/Text.html?is-external=true" title="class or interface in org.apache.hadoop.io">Text</a>&nbsp;url,
                  <a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;datum)</code>
<div class="block">Initialize fetch schedule related data.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/nutch/crawl/AbstractFetchSchedule.html#setConf-org.apache.hadoop.conf.Configuration-">setConf</a></span>(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configuration.html?is-external=true" title="class or interface in org.apache.hadoop.conf">Configuration</a>&nbsp;conf)</code>&nbsp;</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code><a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/nutch/crawl/AbstractFetchSchedule.html#setFetchSchedule-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-long-long-long-long-int-">setFetchSchedule</a></span>(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/io/Text.html?is-external=true" title="class or interface in org.apache.hadoop.io">Text</a>&nbsp;url,
                <a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;datum,
                long&nbsp;prevFetchTime,
                long&nbsp;prevModifiedTime,
                long&nbsp;fetchTime,
                long&nbsp;modifiedTime,
                int&nbsp;state)</code>
<div class="block">Sets the <code>fetchInterval</code> and <code>fetchTime</code> on a
 successfully fetched page.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/nutch/crawl/AbstractFetchSchedule.html#setPageGoneSchedule-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-long-long-long-">setPageGoneSchedule</a></span>(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/io/Text.html?is-external=true" title="class or interface in org.apache.hadoop.io">Text</a>&nbsp;url,
                   <a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;datum,
                   long&nbsp;prevFetchTime,
                   long&nbsp;prevModifiedTime,
                   long&nbsp;fetchTime)</code>
<div class="block">This method specifies how to schedule refetching of pages marked as GONE.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code><a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/nutch/crawl/AbstractFetchSchedule.html#setPageRetrySchedule-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-long-long-long-">setPageRetrySchedule</a></span>(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/io/Text.html?is-external=true" title="class or interface in org.apache.hadoop.io">Text</a>&nbsp;url,
                    <a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;datum,
                    long&nbsp;prevFetchTime,
                    long&nbsp;prevModifiedTime,
                    long&nbsp;fetchTime)</code>
<div class="block">This method adjusts the fetch schedule if fetching needs to be re-tried due
 to transient errors.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/nutch/crawl/AbstractFetchSchedule.html#shouldFetch-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-long-">shouldFetch</a></span>(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/io/Text.html?is-external=true" title="class or interface in org.apache.hadoop.io">Text</a>&nbsp;url,
           <a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;datum,
           long&nbsp;curTime)</code>
<div class="block">This method provides information whether the page is suitable for selection
 in the current fetchlist.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.org.apache.hadoop.conf.Configured">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;org.apache.hadoop.conf.<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configured.html?is-external=true" title="class or interface in org.apache.hadoop.conf">Configured</a></h3>
<code><a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configured.html?is-external=true#getConf--" title="class or interface in org.apache.hadoop.conf">getConf</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.org.apache.hadoop.conf.Configurable">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;org.apache.hadoop.conf.<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configurable.html?is-external=true" title="class or interface in org.apache.hadoop.conf">Configurable</a></h3>
<code><a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configurable.html?is-external=true#getConf--" title="class or interface in org.apache.hadoop.conf">getConf</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="defaultInterval">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>defaultInterval</h4>
<pre>protected&nbsp;int defaultInterval</pre>
</li>
</ul>
<a name="maxInterval">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>maxInterval</h4>
<pre>protected&nbsp;int maxInterval</pre>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="AbstractFetchSchedule--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>AbstractFetchSchedule</h4>
<pre>public&nbsp;AbstractFetchSchedule()</pre>
</li>
</ul>
<a name="AbstractFetchSchedule-org.apache.hadoop.conf.Configuration-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>AbstractFetchSchedule</h4>
<pre>public&nbsp;AbstractFetchSchedule(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configuration.html?is-external=true" title="class or interface in org.apache.hadoop.conf">Configuration</a>&nbsp;conf)</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="setConf-org.apache.hadoop.conf.Configuration-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setConf</h4>
<pre>public&nbsp;void&nbsp;setConf(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configuration.html?is-external=true" title="class or interface in org.apache.hadoop.conf">Configuration</a>&nbsp;conf)</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configurable.html?is-external=true#setConf-org.apache.hadoop.conf.Configuration-" title="class or interface in org.apache.hadoop.conf">setConf</a></code>&nbsp;in interface&nbsp;<code><a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configurable.html?is-external=true" title="class or interface in org.apache.hadoop.conf">Configurable</a></code></dd>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code><a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configured.html?is-external=true#setConf-org.apache.hadoop.conf.Configuration-" title="class or interface in org.apache.hadoop.conf">setConf</a></code>&nbsp;in class&nbsp;<code><a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/conf/Configured.html?is-external=true" title="class or interface in org.apache.hadoop.conf">Configured</a></code></dd>
</dl>
</li>
</ul>
<a name="initializeSchedule-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>initializeSchedule</h4>
<pre>public&nbsp;<a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;initializeSchedule(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/io/Text.html?is-external=true" title="class or interface in org.apache.hadoop.io">Text</a>&nbsp;url,
                                     <a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;datum)</pre>
<div class="block">Initialize fetch schedule related data. Implementations should at least set
 the <code>fetchTime</code> and <code>fetchInterval</code>. The default
 implementation sets the <code>fetchTime</code> to now, using the default
 <code>fetchInterval</code>.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html#initializeSchedule-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-">initializeSchedule</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html" title="interface in org.apache.nutch.crawl">FetchSchedule</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>url</code> - URL of the page.</dd>
<dd><code>datum</code> - datum instance to be initialized (modified in place).</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>adjusted page information, including all original information.
         NOTE: this may be a different instance than @see CrawlDatum, but
         implementations should make sure that it contains at least all
         information from @see CrawlDatum.</dd>
</dl>
</li>
</ul>
<a name="setFetchSchedule-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-long-long-long-long-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setFetchSchedule</h4>
<pre>public&nbsp;<a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;setFetchSchedule(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/io/Text.html?is-external=true" title="class or interface in org.apache.hadoop.io">Text</a>&nbsp;url,
                                   <a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;datum,
                                   long&nbsp;prevFetchTime,
                                   long&nbsp;prevModifiedTime,
                                   long&nbsp;fetchTime,
                                   long&nbsp;modifiedTime,
                                   int&nbsp;state)</pre>
<div class="block">Sets the <code>fetchInterval</code> and <code>fetchTime</code> on a
 successfully fetched page. NOTE: this implementation resets the retry
 counter - extending classes should call super.setFetchSchedule() to
 preserve this behavior.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html#setFetchSchedule-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-long-long-long-long-int-">setFetchSchedule</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html" title="interface in org.apache.nutch.crawl">FetchSchedule</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>url</code> - url of the page</dd>
<dd><code>datum</code> - page description to be adjusted. NOTE: this instance, passed by
          reference, may be modified inside the method.</dd>
<dd><code>prevFetchTime</code> - previous value of fetch time, or 0 if not available.</dd>
<dd><code>prevModifiedTime</code> - previous value of modifiedTime, or 0 if not available.</dd>
<dd><code>fetchTime</code> - the latest time, when the page was recently re-fetched. Most
          FetchSchedule implementations should update the value in @see
          CrawlDatum to something greater than this value.</dd>
<dd><code>modifiedTime</code> - last time the content was modified. This information comes from
          the protocol implementations, or is set to &lt; 0 if not available.
          Most FetchSchedule implementations should update the value in @see
          CrawlDatum to this value.</dd>
<dd><code>state</code> - if <a href="../../../../org/apache/nutch/crawl/FetchSchedule.html#STATUS_MODIFIED"><code>FetchSchedule.STATUS_MODIFIED</code></a>, then the content is considered to be
          "changed" before the <code>fetchTime</code>, if
          <a href="../../../../org/apache/nutch/crawl/FetchSchedule.html#STATUS_NOTMODIFIED"><code>FetchSchedule.STATUS_NOTMODIFIED</code></a> then the content is known to be
          unchanged. This information may be obtained by comparing page
          signatures before and after fetching. If this is set to
          <a href="../../../../org/apache/nutch/crawl/FetchSchedule.html#STATUS_UNKNOWN"><code>FetchSchedule.STATUS_UNKNOWN</code></a>, then it is unknown whether the page was
          changed; implementations are free to follow a sensible default
          behavior.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>adjusted page information, including all original information.
         NOTE: this may be a different instance than @see CrawlDatum, but
         implementations should make sure that it contains at least all
         information from @see CrawlDatum}.</dd>
</dl>
</li>
</ul>
<a name="setPageGoneSchedule-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-long-long-long-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setPageGoneSchedule</h4>
<pre>public&nbsp;<a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;setPageGoneSchedule(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/io/Text.html?is-external=true" title="class or interface in org.apache.hadoop.io">Text</a>&nbsp;url,
                                      <a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;datum,
                                      long&nbsp;prevFetchTime,
                                      long&nbsp;prevModifiedTime,
                                      long&nbsp;fetchTime)</pre>
<div class="block">This method specifies how to schedule refetching of pages marked as GONE.
 Default implementation increases fetchInterval by 50% but the value may
 never exceed <code>maxInterval</code>.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html#setPageGoneSchedule-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-long-long-long-">setPageGoneSchedule</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html" title="interface in org.apache.nutch.crawl">FetchSchedule</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>url</code> - URL of the page.</dd>
<dd><code>datum</code> - datum instance to be adjusted.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>adjusted page information, including all original information.
         NOTE: this may be a different instance than @see CrawlDatum, but
         implementations should make sure that it contains at least all
         information from @see CrawlDatum.</dd>
</dl>
</li>
</ul>
<a name="setPageRetrySchedule-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-long-long-long-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setPageRetrySchedule</h4>
<pre>public&nbsp;<a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;setPageRetrySchedule(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/io/Text.html?is-external=true" title="class or interface in org.apache.hadoop.io">Text</a>&nbsp;url,
                                       <a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;datum,
                                       long&nbsp;prevFetchTime,
                                       long&nbsp;prevModifiedTime,
                                       long&nbsp;fetchTime)</pre>
<div class="block">This method adjusts the fetch schedule if fetching needs to be re-tried due
 to transient errors. The default implementation sets the next fetch time 1
 day in the future and increases the retry counter.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html#setPageRetrySchedule-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-long-long-long-">setPageRetrySchedule</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html" title="interface in org.apache.nutch.crawl">FetchSchedule</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>url</code> - URL of the page.</dd>
<dd><code>datum</code> - page information.</dd>
<dd><code>prevFetchTime</code> - previous fetch time.</dd>
<dd><code>prevModifiedTime</code> - previous modified time.</dd>
<dd><code>fetchTime</code> - current fetch time.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>adjusted page information, including all original information.
         NOTE: this may be a different instance than @see CrawlDatum, but
         implementations should make sure that it contains at least all
         information from @see CrawlDatum.</dd>
</dl>
</li>
</ul>
<a name="calculateLastFetchTime-org.apache.nutch.crawl.CrawlDatum-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>calculateLastFetchTime</h4>
<pre>public&nbsp;long&nbsp;calculateLastFetchTime(<a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;datum)</pre>
<div class="block">This method return the last fetch time of the CrawlDatum</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html#calculateLastFetchTime-org.apache.nutch.crawl.CrawlDatum-">calculateLastFetchTime</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html" title="interface in org.apache.nutch.crawl">FetchSchedule</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the date as a long.</dd>
</dl>
</li>
</ul>
<a name="shouldFetch-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-long-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>shouldFetch</h4>
<pre>public&nbsp;boolean&nbsp;shouldFetch(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/io/Text.html?is-external=true" title="class or interface in org.apache.hadoop.io">Text</a>&nbsp;url,
                           <a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;datum,
                           long&nbsp;curTime)</pre>
<div class="block">This method provides information whether the page is suitable for selection
 in the current fetchlist. NOTE: a true return value does not guarantee that
 the page will be fetched, it just allows it to be included in the further
 selection process based on scores. The default implementation checks
 <code>fetchTime</code>, if it is higher than the <code>curTime</code> it
 returns false, and true otherwise. It will also check that fetchTime is not
 too remote (more than <code>maxInterval</code>, in which case it lowers the
 interval and returns true.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html#shouldFetch-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-long-">shouldFetch</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html" title="interface in org.apache.nutch.crawl">FetchSchedule</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>url</code> - URL of the page.</dd>
<dd><code>datum</code> - datum instance.</dd>
<dd><code>curTime</code> - reference time (usually set to the time when the fetchlist
          generation process was started).</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true, if the page should be considered for inclusion in the current
         fetchlist, otherwise false.</dd>
</dl>
</li>
</ul>
<a name="forceRefetch-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-boolean-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>forceRefetch</h4>
<pre>public&nbsp;<a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;forceRefetch(<a href="https://hadoop.apache.org/docs/r3.1.3/api/org/apache/hadoop/io/Text.html?is-external=true" title="class or interface in org.apache.hadoop.io">Text</a>&nbsp;url,
                               <a href="../../../../org/apache/nutch/crawl/CrawlDatum.html" title="class in org.apache.nutch.crawl">CrawlDatum</a>&nbsp;datum,
                               boolean&nbsp;asap)</pre>
<div class="block">This method resets fetchTime, fetchInterval, modifiedTime,
 retriesSinceFetch and page signature, so that it forces refetching.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html#forceRefetch-org.apache.hadoop.io.Text-org.apache.nutch.crawl.CrawlDatum-boolean-">forceRefetch</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/apache/nutch/crawl/FetchSchedule.html" title="interface in org.apache.nutch.crawl">FetchSchedule</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>url</code> - URL of the page.</dd>
<dd><code>datum</code> - datum instance.</dd>
<dd><code>asap</code> - if true, force refetch as soon as possible - this sets the
          fetchTime to now. If false, force refetch whenever the next fetch
          time is set.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>adjusted page information, including all original information.
         NOTE: this may be a different instance than @see CrawlDatum, but
         implementations should make sure that it contains at least all
         information from @see CrawlDatum.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/AbstractFetchSchedule.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../org/apache/nutch/crawl/AdaptiveFetchSchedule.html" title="class in org.apache.nutch.crawl"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/apache/nutch/crawl/AbstractFetchSchedule.html" target="_top">Frames</a></li>
<li><a href="AbstractFetchSchedule.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &copy; 2021 The Apache Software Foundation</small></p>
</body>
</html>
